from Plugins.Plugin import PluginDescriptor
from ServiceReference import ServiceReference

from Screens.Screen import Screen
from Screens.InputBox import InputBox
from Screens.MessageBox import MessageBox
from Components.ServicePosition import ServicePositionGauge
from Components.ActionMap import HelpableActionMap
from Components.MenuList import MenuList
from Components.MultiContent import MultiContentEntryText
from Components.ServiceEventTracker import ServiceEventTracker
from Components.ActionMap import ActionMap
from Components.Input import Input
from Screens.InfoBarGenerics import InfoBarSeek, InfoBarCueSheetSupport
from Components.GUIComponent import GUIComponent
from enigma import eListboxPythonMultiContent, eListbox, gFont, iPlayableService, RT_HALIGN_RIGHT, eServiceCenter, eServiceReference, iServiceInformation
from Screens.FixedMenu import FixedMenu
from Tools.Directories import *
import os
from time import *
import time
import datetime


def main(session, service, **kwargs):
	session.open(RenameMovie, service)

def Plugins(**kwargs):
 	return PluginDescriptor(name="Rename Movies Plugin", description=_("rename ..."), where = PluginDescriptor.WHERE_MOVIELIST, fnc=main)


class RenameMovie(Screen):
    skin = """
        <screen position="100,100" size="500,200" title="Rename Movie Menu" >
            <widget name="menu" position="10,10" size="490,190" scrollbarMode="showOnDemand" />
        </screen>"""
        
    def __init__(self, session, service, args = 0):
        self.skin = RenameMovie.skin
        self.session = session
        Screen.__init__(self, session)
        self.menu = args
        list = []
        session.nav.playService(service)
	self.service = self.session.nav.getCurrentlyPlayingServiceReference()
	serviceHandler = eServiceCenter.getInstance()
	info = serviceHandler.info(self.service)
	self.oldname = info and info.getName(self.service) or _("this recording")
        if self.oldname.endswith(".ts") is True:
           list.append((_("rename .ts file"), "renamets"))
        elif self.oldname.endswith(".mpg") is True:
           list.append((_("rename .mpg file"), "renamempg"))
           list.append((_("remove .mpg file"), "removempg"))
        else:
           list.append((_("rename movie"), "renamemovie"))
       
        list.append((_("about"), "about"))        
        self["menu"] = MenuList(list)
        self["actions"] = ActionMap(["WizardActions", "DirectionActions"],{"ok": self.go,"back": self.close,}, -1)
        
    def go(self):
        returnValue = self["menu"].l.getCurrentSelection()[1]
        if returnValue is not None:
           if returnValue is "renamemovie":
              RenameMovieFiles(self.session)
           elif returnValue is "renamets":
              RenamePlainFile(self.session,".ts")
           elif returnValue is "renamempg":
              RenamePlainFile(self.session,".mpg")
           elif returnValue is "removempg":
              print "remove: %s" % self.oldname
              if os.path.exists("/media/hdd/movie/%s" % self.oldname) is True:
                 os.remove("/media/hdd/movie/%s" % self.oldname)
                 self.session.open(MessageBox,_("file successfully removed"), MessageBox.TYPE_INFO)
              else:
                 self.session.open(MessageBox,_("file not found for remove"), MessageBox.TYPE_WARNING)
           elif returnValue is "about":
              self.session.open(MessageBox,_("Rename Movie Enigma2 Plugin\nVersion 3.2 by gutemine"), MessageBox.TYPE_INFO)
        

class RenameMovieFiles(Screen):
    def __init__(self, session):

        self.session = session
	self.service = self.session.nav.getCurrentlyPlayingServiceReference()
	serviceHandler = eServiceCenter.getInstance()
	info = serviceHandler.info(self.service)
	self.oldname = info and info.getName(self.service) or _("this recording")
        service = ServiceReference(info.getInfoString(self.service, iServiceInformation.sServiceref))
	self.station = service.getServiceName()
	self.begin = info.getInfo(self.service, iServiceInformation.sTimeCreate)
        jetzt = time.time()
        timezone = datetime.datetime.utcnow()
        delta = (jetzt - time.mktime(timezone.timetuple()))/3600 
#       print "delta: %i" % delta
        self.begin_string = strftime("%Y%m%d %H%M",gmtime(self.begin+3600*int(delta)))
        fullnameunchecked = "%s - %s - %s" % (self.begin_string,self.station,self.oldname)
        # use enigma2 filename routine - thank's ritzMo !
        fullname=getRecordingFilename(fullnameunchecked)
        # quick & dirty header & trailer remove 
        fullname=fullname.replace("_001","",1)
        fullname=fullname.replace("/hdd/movie/","",1)
        print "1st try: %s" % fullname
        splitname=[]
        if fullname.endswith("Rund um die Uhr bestellbar") is True:
           splitname=fullname.rsplit(" ",7)
           fullname="%s %s_%s - Rund um die Uhr bestellbar" % (splitname[0],splitname[1][0:2],splitname[1][2:4])
        if os.path.exists("/media/hdd/movie/%s.ts.meta" % fullname) is False:
           self.begin_string = strftime("%Y%m%d %H%M",gmtime(self.begin+3600*(int(delta)-1)))
           fullnameunchecked = "%s - %s - %s" % (self.begin_string,self.station,self.oldname)
           # use enigma2 filename routine - thank's ritzMo !
           fullname=getRecordingFilename(fullnameunchecked)
           # quick & dirty header & trailer remove 
           fullname=fullname.replace("_001","",1)
           fullname=fullname.replace("/hdd/movie/","",1)
           print "2nd try: %s" % fullname
           if fullname.endswith("Rund um die Uhr bestellbar") is True:
              splitname=fullname.rsplit(" ",7)
              fullname="%s %s_%s - Rund um die Uhr bestellbar" % (splitname[0],splitname[1][0:2],splitname[1][2:4])
           if os.path.exists("/media/hdd/movie/%s.ts.meta" % fullname) is False:
              self.begin_string = strftime("%Y%m%d %H%M",gmtime(self.begin+3600*(int(delta)+1)))
              fullnameunchecked = "%s - %s - %s" % (self.begin_string,self.station,self.oldname)
              # use enigma2 filename routine - thank's ritzMo !
              fullname=getRecordingFilename(fullnameunchecked)
              # quick & dirty header & trailer remove 
              fullname=fullname.replace("_001","",1)
              fullname=fullname.replace("/hdd/movie/","",1)
              print "3rd try: %s" % fullname
              if fullname.endswith("Rund um die Uhr bestellbar") is True:
                 splitname=fullname.rsplit(" ",7)
                 fullname="%s %s_%s - Rund um die Uhr bestellbar" % (splitname[0],splitname[1][0:2],splitname[1][2:4])
        self.oldfullname=fullname
        if os.path.exists("/media/hdd/movie/%s.ts.meta" % self.oldfullname) is True:
           print "renaming %s files" % fullname
           metafile = open("/media/hdd/movie/%s.ts.meta" % self.oldfullname, "r")
           self.sid=metafile.readline()
           text=metafile.readline()
           self.olddescription=metafile.readline().rstrip()
           self.rest=metafile.read()
           metafile.close()
           self.session.openWithCallback(self.askForNewName,InputBox, title=_("Enter new name for movie"), text="%s %s                              " % (self.oldname,self.olddescription), type=Input.TEXT)
        else:
           self.skipRenameMovie("%s.ts.meta NOT found" % self.oldfullname)

    def askForNewName(self,newname):
        if newname is None:
           self.skipRenameMovie("no new name for movie")
        else:
           self.newname = newname.lstrip().rstrip()
           fullnameunchecked = "%s - %s - %s" % (self.begin_string,self.station,self.newname)
           # use enigma2 filename routine - thank's ritzMo !
           fullname=getRecordingFilename(fullnameunchecked)
           # quick & dirty header & trailer remove 
           fullname=fullname.replace("_001","",1)
           fullname=fullname.replace("/hdd/movie/","",1)
           print "checking for new %s files" % fullname
           self.newfullname=fullname.rstrip()
           self.session.openWithCallback(self.askForNewDescription,InputBox, title=_("Enter new Description for movie"), text="%s %s                              " % (self.oldname,self.olddescription), type=Input.TEXT)

    def askForNewDescription(self,newdescription):
        if newdescription is None:
            self.skipRenameMovie("no new description for movie")
        else:
            self.newdescription = newdescription.lstrip().rstrip()
            self.session.openWithCallback(self.RenameMovieNow,MessageBox,_("rename %s to %s ?" % (self.oldname,self.newname)), MessageBox.TYPE_YESNO)

    def RenameMovieNow(self,answer):
        if answer is None:
            self.skipRenameMovie("answer is None")
        if answer is False:
            self.skipRenameMovie("you were not confirming")
        else:
            if os.path.exists("/media/hdd/movie/%s.ts.meta" % self.oldfullname) is True:
               metafile = open("/media/hdd/movie/%s.ts.meta" % self.oldfullname, "w")
               metafile.write("%s%s\n%s\n%s" %(self.sid, self.newname,self.newdescription,self.rest))
               metafile.close()
               os.rename("/media/hdd/movie/%s.ts.meta" % self.oldfullname, "/media/hdd/movie/%s.ts.meta" % self.newfullname)
            if os.path.exists("/media/hdd/movie/%s.eit" % self.oldfullname) is True:
               os.rename("/media/hdd/movie/%s.eit" % self.oldfullname, "/media/hdd/movie/%s.eit" % self.newfullname)
            if os.path.exists("/media/hdd/movie/%s.ts.ap" % self.oldfullname) is True:
               os.rename("/media/hdd/movie/%s.ts.ap" % self.oldfullname, "/media/hdd/movie/%s.ts.ap" % self.newfullname)
            if os.path.exists("/media/hdd/movie/%s.ts.cuts" % self.oldfullname) is True:
               os.rename("/media/hdd/movie/%s.ts.cuts" % self.oldfullname, "/media/hdd/movie/%s.ts.cuts" % self.newfullname)
            if os.path.exists("/media/hdd/movie/%s.ts" % self.oldfullname) is True:
               os.rename("/media/hdd/movie/%s.ts" % self.oldfullname, "/media/hdd/movie/%s.ts" % self.newfullname)
            self.session.open(MessageBox,_("rename movie done, check by pressing Video button again !"), MessageBox.TYPE_INFO)
            
    def skipRenameMovie(self,reason):
        self.session.open(MessageBox,_("renaming movie was cancelled, because %s" % reason), MessageBox.TYPE_WARNING)
        
        
class RenamePlainFile(Screen):
    def __init__(self, session, endung):

        self.session = session
	self.service = self.session.nav.getCurrentlyPlayingServiceReference()
	serviceHandler = eServiceCenter.getInstance()
	info = serviceHandler.info(self.service)
	filename = info and info.getName(self.service) or _("this recording")
        self.endung=endung
        filename=filename.replace("/hdd/movie/","",1)
        parts=[]
        if self.endung == ".ts":
           # cut off .ts
           parts=filename.split(".ts",1)
           self.oldfilename=parts[0]
        elif self.endung == ".mpg":
           # cut off .mpg
           parts=filename.split(".mpg",1)
           self.oldfilename=parts[0]
        else:
           self.skipRenamePlainFile("unsupported file extension")
        
        self.session.openWithCallback(self.askForNewFileName,InputBox, title=_("Enter new name for movie"), text="%s                                        " % self.oldfilename, maxSize=50, type=Input.TEXT)

    def askForNewFileName(self,newfilename):
        if newfilename is None:
           self.skipRenamePlainFile("no new name")
        else:
           self.newfilename=newfilename.rstrip()
           if os.path.exists("/media/hdd/movie/%s%s" % (self.newfilename,self.endung)) is True:
              self.skipRenamePlainFile("new file name already exists")
           else:
              if os.path.exists("/media/hdd/movie/%s%s" % (self.oldfilename,self.endung)) is True:
                 os.rename("/media/hdd/movie/%s%s" % (self.oldfilename,self.endung), "/media/hdd/movie/%s%s" % (self.newfilename,self.endung))
                 for x in range(1,9):
                   if os.path.exists("/media/hdd/movie/%s%s.00%i" % (self.oldfilename,self.endung,x)) is True:
                      os.rename("/media/hdd/movie/%s%s.00%i" % (self.oldfilename,self.endung,x), "/media/hdd/movie/%s%s.00%i" % (self.newfilename,self.endung,x))
                 if os.path.exists("/media/hdd/movie/%s%s.cuts" % (self.oldfilename,self.endung)) is True:
                    os.rename("/media/hdd/movie/%s%s.cuts" % (self.oldfilename,self.endung), "/media/hdd/movie/%s%s.cuts" % (self.newfilename,self.endung))
                 if os.path.exists("/media/hdd/movie/%s.eit" % (self.oldfilename)) is True:
                    os.rename("/media/hdd/movie/%s.eit" % (self.oldfilename), "/media/hdd/movie/%s.eit" % (self.newfilename))
                 self.session.open(MessageBox,_("rename movie file done, check by pressing Video button again !"), MessageBox.TYPE_INFO)
              else:
                 self.skipRenamePlainFile("file not found")
            
    def skipRenamePlainFile(self,reason):
        self.session.open(MessageBox,_("rename movie file was cancelled, because %s" % reason), MessageBox.TYPE_WARNING)
        
        
